"""Utilities for make the code run both on Python2 and Python3.
"""
import sys

PY2 = sys.version_info[0] == 2

# urljoin
if PY2:
    from urllib.parse import urljoin
else:
    from urllib.parse import urljoin

# Dictionary iteration
if PY2:
    iterkeys = lambda d: iter(d.keys())
    itervalues = lambda d: iter(d.values())
    iteritems = lambda d: iter(d.items())
else:
    iterkeys = lambda d: iter(list(d.keys()))
    itervalues = lambda d: iter(list(d.values()))
    iteritems = lambda d: iter(list(d.items()))

# string and text types
if PY2:
    text_type = str
    string_types = (str, str)
else:
    text_type = str
    string_types = (str,)

# imap
#if PY2:
#	from itertools import imap
#else:
imap = map
